---
layout: layouts/exercise_base.njk
exercise: Introduction to OOP
---

<p>Before submitting your solutions, make sure that <kbd>cppcheck</kbd>
  doesn't show any errors.
</p>

<ol>
  <li><strong>Circle</strong><br />
    Create the following files: <kbd>main.cpp</kbd>, <kbd>circle.hpp</kbd>,
    <kbd>circle.cpp</kbd> and <kbd>Makefile</kbd>.
    The <code>Circle</code> class in the
    <a href="/presentations/cpp/oop/classes/#/4/1">slides</a> is incomplete.
    Implement the <code>area()</code> and <code>circumference()</code> functions.
    Think about different implementation strategies (calculation upon calls to
    the function, calculation upon call to radius or a caching strategy).
    Explain your decision in comments.<br />
    Create a <kbd>Makefile</kbd> for compiling your code.
  </li>

  <li><strong>Bank Account</strong><br />
    Create an <code>Account</code> class for managing bank account information.
    The class must be defined in <kbd>account.hpp</kbd>
    and the non-trivial methods in <kbd>account.cpp</kbd>. Both must be
    implemented inside of a <kbd>bank</kbd> namespace. Use the
    <code>Account</code> in this mini-project's <kbd>main.cpp</kbd> file:
    <ul>
      <li>create at least two different accounts</li>
      <li>perform multiple deposits and withdrawals</li>
      <li>display the final balance</li>
    </ul>
    Provide a <kbd>Makefile</kbd> that compiles the project.<br />
    The bank account must
    follow the specification in the class diagram below:<br />
    <img src="/images/uml/account.svg" alt="[Bank Account Class Diagram]">
    <br />
    The first three lines in the diagram are data members. The minus in front
    of them indicates that they are private members. The remaining entries
    are methods with the plus indicating public access.
    <br />
    The amounts are stored as integral numbers to avoid problems with
    floating point precision. The amount stored in the balance represents
    cents. A balance of 172042 corresponds hence to 1720 Euros and 42 Cents.
    Note that the <code>withdraw(.)</code> methods returns the amount
    actually withdrawn which will help us when subclassing the Account in the
    future.<br />
    Override the
    <a href="/presentations/cpp/operator_overloading/#/2/4">
      <code>&lt;&lt;</code> operator
    </a> to print account data
    (account number and current balance in Euro and Cent).
  </li>

  <li><strong>Rolling a Die</strong><br />
    Implement a class for rolling a six-sided die. The class should store the
    last result in a private variable. In addition, it should keep stats
    of how many times each number was thrown in an appropriate data structure.
    The API of the class must offer four public methods:
{% highlight "cpp" %}
// reset all stats to 0
void reset();

// create a random integer 1..6, store it as private property and return it
int roll();

/* print the stats, one per line (eg.
1: 45
2: 53
...
 */
void print_stats();

// return the stored integer result from the last toss
int value();
{% endhighlight %}
    In <code>main(.)</code>, instantiate an object of the above class, roll the
    die 10000 times and print the stats to <code>stdout</code>.
    <br />
    Name the source file: <kbd>rolling_a_die.cpp</kbd>
  </li>

  <li><strong>Roulette</strong><br />
    Implement a class for playing a simplified
    <a href="https://en.wikipedia.org/wiki/Roulette">roulette</a> game.
    The class must store the most recent number.
    It must offer an API to start a new game
    and interpret the resulting number.
{% highlight "cpp" %}
bool is_black();
bool is_even();  // aka. pair
bool is_high();  // the number was between 19..36 (passe)
bool is_low();  // the number was between 1..18 (manque)
bool is_odd();  // aka. impair
bool is_red();
bool is_zero();

// create a random integer 0..36, store it as private property and return it
int roll();

// return the stored integer
int value();
{% endhighlight %}
    Name the source file: <kbd>roulette.cpp</kbd>
  </li>
  {#
  class DateTime

  initialized with minutes=... hours=... where the class takes care that the
  time is valid and in a commonly used format

  #}

{#
  for homework that involves templates etc.
  create homework task: implement vector class + implement the following own / additional test cases
#}
</ol>
